# - Try to find ATI Stream
# Once done this will define
#  INTEL_OPENCL_TOOLKIT_FOUND
#  INTEL_OPENCL_TOOLKIT_ROOT_DIR
#  INTEL_OPENCL_TOOLKIT_INCLUDE_DIRS
#  INTEL_OPENCL_TOOLKIT_LIBRARIES


if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(INTEL_ARCHEXT "64")
else(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(INTEL_ARCHEXT "32")
endif(CMAKE_SIZEOF_VOID_P EQUAL 8)


FILE(GLOB INTEL_OPENCL_TOOLKIT_SEARCH_PATH 
    "/opt/intel"
    "/opt/intel/opencl"
    "/opt/intel/OpenCL"
    "/usr/lib/OpenCL/vendors/intel"
    "/usr/local/lib/OpenCL/vendors/intel"
)

FIND_PATH(INTEL_OPENCL_TOOLKIT_ROOT_DIR
  NAMES 
    libintelocl.so
  PATHS
    ENV LD_LIBRARY_PATH
    ${INTEL_OPENCL_TOOLKIT_SEARCH_PATH}
  PATH_SUFFIXES
    lib
    lib${INTEL_ARCHEXT}
)


FIND_PATH(INTEL_OPENCL_TOOLKIT_INCLUDE_DIRS
  NAMES
    CL/cl.h 
  PATHS
    ${ATI_TOOLKIT_ROOT_DIR}/include
)

FIND_LIBRARY(INTEL_OPENCL_TOOLKIT_LIBRARIES
  NAMES
    intelocl 
  PATHS
    ${INTEL_OPENCL_TOOLKIT_SEARCH_PATH}
  PATH_SUFFIXES
    lib
    lib${INTEL_ARCHEXT}
)

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(INTEL_OPENCL_TOOLKIT DEFAULT_MSG INTEL_OPENCL_TOOLKIT_INCLUDE_DIRS INTEL_OPENCL_TOOLKIT_LIBRARIES)
    
mark_as_advanced(INTEL_OPENCL_TOOLKIT_INCLUDE_DIRS INTEL_OPENCL_TOOLKIT_LIBRARIES)
