# - Try to find the Intel Math Kernel Library
# Once done this will define
#
#  OCLFFT_FOUND - system has MKL
#  OCLFFT_ROOT_DIR - path to the MKL base directory
#  OCLFFT_INCLUDE_DIRS - the MKL include directory
#  OCLFFT_LIBRARIES - MKL libraries
#

find_path(OCLFFT_ROOT_DIR
    clFFT.h
    PATHS
        ENV LD_LIBRARY_PATH
	"../oclfft/"
	"~/oclfft/"
)
find_path(OCLFFT_INCLUDE_DIRS clFFT.h ${OCLFFT_ROOT_DIR})


find_library(OCLFFT_LIBRARIES
  oclfft
  PATHS
    "${OCLFFT_ROOT_DIR}"
)

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(OCLFFT DEFAULT_MSG OCLFFT_INCLUDE_DIRS OCLFFT_LIBRARIES)
    
mark_as_advanced(OCLFFT_INCLUDE_DIRS OCLFFT_LIBRARIES)
