__global__ static void hst_cuda_kernel(int num_proj, int num_bins, float *d_SLICE, float apos_off_x, float apos_off_y, int batch) {
    int i;
    int proj;
    
    const int tidx = threadIdx.x;
    const int tidy = threadIdx.y;

    const int bidx = blockIdx.x * BLOCK_SIZE_X;
    const int bidy = batch + blockIdx.y * BLOCK_SIZE_Y;

    const int idx = bidx + threadIdx.x;
    const int idy = bidy + threadIdx.y;

    float4 all;

    float res = 0;

    const float bx = bidx + apos_off_x;
    const float by = bidy + apos_off_y;

    const float x = bx + tidx;
    const float y = by + tidy;

    float h;
    int minh;

    __shared__  float   cache_subh[BLOCK_SIZE_X][BLOCK_SIZE_Y + 1];
    __shared__  float   cache_sin[BLOCK_SIZE_Y];
    __shared__  float   cache[BLOCK_SIZE_Y][2 * BLOCK_SIZE_X + 1];
    
//#pragma unroll 8
    for (int proje=0; proje<num_proj; proje += BLOCK_SIZE_Y) {
	int proj = proje + tidy;

        all = c_all[proj];
	h = all.z + bx * all.x - by * all.y;
//	minh = (int)floor(h + BLOCK_SIZE * min(min(all.x, -all.y), min(0., all.x - all.y)));
	minh = (int)(h + all.w);
		
//#pragma unroll 2
	for (i = 0; i < 2; i++) {
	    int pos = i * BLOCK_SIZE_X + tidx;
	    cache[tidy][pos] = tex2D(tex_projes, minh + pos, proje + tidy);
	}

	cache_subh[tidx][tidy] = all.z + x * all.x - minh;
	if (tidx == 0) cache_sin[tidy] = all.y;

	__syncthreads();

	
//#pragma unroll 16
	for (i = 0; i < BLOCK_SIZE_Y; i++) {
	    minh = cache_subh[tidx][i] - y * cache_sin[i];
	    res += cache[i][minh];

/*		// Linear
	    h = cache_subh[tidx][i] - y * cache_sin[i];
	    minh = (int)h;
	    res += cache[i][minh] + (h - minh) * (cache[i][minh + 1] - cache[i][minh]);
*/
	}


	__syncthreads();

    }

    d_SLICE[ BLOCK_SIZE_X*gridDim.x*idy + idx ] = res;
}
