__global__ static void hst_cuda_kernel(int num_proj, int num_bins, float *d_SLICE, float apos_off_x, float apos_off_y, int batch) {
    int i;
    int proj;
    
    const int tidx = threadIdx.x;
    const int tidy = threadIdx.y;

    const int bidx = blockIdx.x * BLOCK_SIZE_X;
    const int bidy = batch + blockIdx.y * BLOCK_SIZE_Y;

    const int idx = bidx + threadIdx.x;
    const int idy = bidy + threadIdx.y;

    float4 all1, all2;

    float res = 0;

    const float bx = bidx + apos_off_x;
    const float by = bidy + apos_off_y;

    const float x = bx + tidx;
    const float y = by + tidy;

    int minh1, minh2;

    __shared__  short2   cache_subh[BLOCK_SIZE_X][BLOCK_SIZE_Y + 1];
    __shared__  short2   cache_sin[2 * BLOCK_SIZE_Y];
    __shared__  float   cache[2 * BLOCK_SIZE_Y][24];

    int prj = tidx >> 3;
    int pos = BLOCK_SIZE_X + (tidx & 7);
//	int prj = tidx&1;
//	int pos = BLOCK_SIZE_X + (tidx >> 1);

    int tidy2 = tidy << 1;
    int tidy21 = tidy2 + 1;
    int tidy2p = tidy2 + prj;


//#pragma unroll 8
    for (int proje=0; proje<num_proj; proje += 2 * BLOCK_SIZE_Y) {
	int proj = proje + tidy2;
	
        all1 = c_all[proj];
        all2 = c_all[proj + 1];
	minh1 = (int)(all1.z + bx * all1.x - by * all1.y + all1.w);
	minh2 = (int)(all2.z + bx * all2.x - by * all2.y + all2.w);
		
	cache[tidy2][tidx] = tex2D(tex_projes, minh1 + tidx, proj);
	cache[tidy21][tidx] = tex2D(tex_projes, minh2 + tidx, proj + 1);
        cache[tidy2p][pos] = tex2D(tex_projes, (prj?minh2:minh1) + pos, proj + prj);

	cache_subh[tidx][tidy].x = __float2half_rn(all1.z + x * all1.x - by * all1.y - minh1);
	cache_subh[tidx][tidy].y = __float2half_rn(all2.z + x * all2.x - by * all2.y - minh2);
	
	if (tidx == 0) {
	    cache_sin[tidy].x = __float2half_rn(all1.y);
	    cache_sin[tidy].y = __float2half_rn(all2.y);
	}

	__syncthreads();

#pragma unroll 16
	for (i = 0; i < BLOCK_SIZE_Y; i++) {
	    int j = 2 * i;
	    short2 subh = cache_subh[tidx][i];
	    short2 sinh = cache_sin[i];
	    
	    minh1 = __half2float(subh.x) - tidy * __half2float(sinh.x);
	    res += cache[j][minh1];

	    ++j;
	    minh1 = __half2float(subh.y) - tidy * __half2float(sinh.y);
	    res += cache[j][minh1];
	}

	__syncthreads();

    }

    d_SLICE[ BLOCK_SIZE_X*gridDim.x*idy + idx ] = res;
}
