
#include"Python.h"
#include"structmember.h"
#include<string.h>

#include "numpy/arrayobject.h"

#ifdef LINUX
 #define _FILE_OFFSET_BITS  64
#endif


#define DEBUG(a)


 /* The error object to expose 
 */

static PyObject *ErrorObject;
#define onError(message)\
  { PyErr_SetString(ErrorObject, message); return NULL;}


#define  __CCD_Filter_name__  "interpola_filter"
#define __init__Filter__      initinterpola_filter

static char Filter_doc[]="";

static PyObject *
Filter(PyObject *self_a, PyObject *args)
{
  PyObject * A         ;
  PyObject * pos_      ;
  PyObject * siz_      ;
  PyObject * pos       ;
  PyObject * siz       ;
  PyObject * tmp;
  char msg[400];
  
  int x0_,x1_, x0,x1, s0_,s1_,s0,s1;
  int X0,X1,X0_, X1_;
  int dim0, dim1;
  int nsum;
  int ds;


  int c0 = 0, c1 = 0;
  int c0_,c1_;
  float temp[9];
  float swap;
  int bool;
  int count;


  PyObject * dic_key;
  PyObject * dic_value;
  double threshold ;

  int i;


  int *iptr[] = { &x0_ , &x1_  ,&x0 , &x1 , &s0_ , &s1_ , &s0 , &s1 };

  int shift_x[] = { -1,-1,-1, 0, 0,  0, 1,  1, 1  };
  int shift_y[] = { -1, 0, 1,-1, 0, 1,-1,  0, 1  };
  int si;

  PyObject ** containers[] = {&pos_ , &pos, &siz_, &siz   };


  float * a_data;
  float * m_data;
  double shift;
  double fact1, fact2;
  int ishift1, ishift2;



 if(!PyArg_ParseTuple(args,"OOOOOf:CDD_Filter",&A,&pos_,&siz_, &pos, &siz, &shift ))
   return NULL;

 /* check the Objects */

  if(!PyArray_Check(A ))    onError("not a PyArray, argument 1");
  if(!PyList_Check (pos_ ) )     onError("not a PyList, argument 2");
  if(!PyList_Check (siz_ ))    onError("not a PyList, argument 3");
  if(!PyList_Check (pos ))         onError("not a PyList, argument 4");
  if(!PyList_Check(siz ))       onError("not a PyList, argument 5");

  /* check the types */

  if( ((PyArrayObject *) A )  ->descr->type_num != PyArray_FLOAT ) onError(" arg 1 is not an array of float " ) ;

  /* check n of dimensione */

  if( ((PyArrayObject *) A)->nd !=2)  onError(" arg 1 is not a matrix " ) ;
 

  /* check contiguity */

  if(  ((PyArrayObject *) A) ->flags %2 == 0) onError(" array has to be contiguous");

  a_data = (float *) ((PyArrayObject *) A)->data;
  /* getting positions and sizes */

  for (i=0; i<8; i++) {
    tmp =  PyList_GetItem( *(containers[i/2])  , i%2);
    if(!PyInt_Check( tmp )) {
      sprintf(msg, " not an integer, item %d of argument %d", i%2, i/2+2);
      onError(msg);
    }
    *iptr[i] = PyInt_AS_LONG( tmp ); 
  }



  /* setting better the limits ( they were indexed by iptr )*/

  x0 = x0 - x0_ ;
  x1 = x1 - x1_ ;
  
  x0_ = 0 ;
  x1_ = 0 ;
  

  X0 = x0 + s0 ;
  X1 = x1 + s1 ;
  
  X0_ = x0_ + s0_ ;
  X1_ = x1_ + s1_ ;


  /* checking that the supllied limits are not completely wrong */

  if ( ((PyArrayObject *) A)->dimensions[0] != s0_  || ((PyArrayObject *) A)->dimensions[1] != s1_  ) {
    onError(" array dimension and supplied limits are not consistent");
  }
  
  dim0 = s0_;
  dim1 = s1_;
  
  /* straighforward addressing scheme in case of contiguous memory. Or you'll need to use strides */


  m_data=(float*) malloc( dim0*dim1 * sizeof(float) ) ;
  memset(m_data , 0  , dim0*dim1*sizeof(float) );


  



#define AA(i,j)  a_data[(i)*dim1+(j)    ]
#define MM(i,j)  m_data[(i)*dim1+(j)    ]  

  ishift1= (int) shift;

  if(shift<0) ishift1--;

  ishift2= ishift1+1;

  fact1 = ishift2-shift;
  fact2 = shift-ishift1;





  if( x0 !=0 ) {   /* verticale */

    for(c0=x0  ; c0< X0 ; c0++) {
      if( c0+ishift1 < x0_  || c0+ishift2 >= X0_ ) {
	MM(c0,c1) =AA(c0,c1) ;
      } else {
	for(c1=x1; c1< X1 ; c1++) {
	  MM(c0,c1) = fact1 * AA(c0+ishift1, c1) + fact2 * AA( c0+ishift2, c1);
	}
      }
    }
  }  else {
    
    for(c1=x1  ; c1< X1 ; c1++) {
      if( c1+ishift1 < x1_  || c1+ishift2 >= X1_ ) {
	MM(c0,c1) =AA(c0,c1) ;
      } else {
	for(c0=x0; c0< X0 ; c0++) {
	  MM(c0,c1) = fact1 * AA(c0, c1+ishift1) + fact2 * AA( c0, c1+ishift2);
	}
      }
    }
  }
  
  
  
  memcpy( a_data, m_data, dim0*dim1*sizeof(float) );
  free(m_data);
  Py_INCREF(Py_None);
  return Py_None;
    
}



static PyMethodDef CCD_Filter_functions [] = {
  {"Filter", Filter,  METH_VARARGS, Filter_doc},
  { NULL, NULL}
};






void 
__init__Filter__   ()
{
  PyObject *m, *d;
  m = Py_InitModule(  __CCD_Filter_name__    ,  CCD_Filter_functions  );
  d = PyModule_GetDict(m);
  ErrorObject = Py_BuildValue("s",  __CCD_Filter_name__  ".error");
  PyDict_SetItemString(d,"error", ErrorObject);
  if(PyErr_Occurred())
    Py_FatalError("can't initialize module " __CCD_Filter_name__  );

#ifdef import_array
  import_array();
#endif
}

