#!/usr/bin/env python
# To use:
#       python setup.py install
#
import os, sys, string, re
from glob import glob
import numpy    
import distutils
from distutils.command.install import install
from distutils.core import setup, Extension

headers = glob (os.path.join ("Include","*.h") )
header = headers + glob (os.path.join (numpy.get_include() + "/numpy","*.h") ) 

# The version is set in Lib/numeric_version.py

setup (name = "extension",
       description = " Extension to Python",
       include_dirs = numpy.get_include(),
       ext_modules = [Extension('interpola_filter',
                                ['interpola_filter.c'],
                                libraries=['gcc','m']),
                      Extension('CCD_Filter',
                                ['CCD_Filter_Template.c'],
                                libraries=['gcc','m']),
		      Extension('CCD_FilterAbsRel',
                                ['CCD_FilterAbsRel.c'],
                                libraries=['gcc','m']),
		      Extension('CCD_Filter2',
                                ['CCD_Filter_Template_bis.c'],
                                libraries=['gcc','m']),
		      Extension('CCD_FilterMIN',
                                ['CCD_Filter_MIN.c'],
                                libraries=['gcc','m']),
		      Extension('SINO_Filter',
                                ['SINO_Filter_Template.c',"Vhst_fourier.c"],
                                libraries=['gcc','m']),
		      Extension('SINO_Filter_Median',
                                ['SINO_Filter_Median.c',"Vhst_fourier.c"],
                                libraries=['gcc','m']),
		      Extension('SINO_Filter_Smooth',
                                ['SINO_Filter_Smooth.c',"Vhst_fourier.c"],
                                libraries=['gcc','m']),

                     ]
       )







