#define MAXNPROJECTIONS 4096			//!< Maximum number of supported projections per slices
#define HST_CUDA_MAX_DEVICES 16			//!< Maximum CUDA-devices supported by the module (check tex_projes)

#define BLOCK_SIZE 16				//!< CUDA block size (for filtering)
#define BLOCK_SIZE_X BLOCK_SIZE			//!< Check kernels, there are some expectations
#define BLOCK_SIZE_Y BLOCK_SIZE			//!< Check kernels, there are some expectations

    /* We should be carefoul here, in many cases it faster to preform everything at once
    probably due to the texture caching */
#ifdef HST_OPTIMIZE_KEPLER
# define BP_BATCH_SIZE 128			//!< Batch size (in blocks) for Back Projection  (should be even)
#else /* HW_OPTIMIZE_KEPLER */
# ifdef  HW_IGNORE_OLD_HARDWARE
#  define BP_BATCH_SIZE 128			//!< Batch size (in blocks) for Back Projection  (should be even)
# else /*  HW_IGNORE_OLD_HARDWARE */
#  define BP_BATCH_SIZE 8			//!< Batch size (in blocks) for Back Projection  (should be even)
 #endif /*  HW_IGNORE_OLD_HARDWARE */
#endif /*  HW_OPTIMIZE_KEPLER */
#define FFT_BATCH_SIZE 8			//!< Batch size (in blocks) for FFT transformations (should be even)
