#include <smmintrin.h>

#define fast_memcpy memcpy

void fast_memcpy_1(void *dst, void *src, size_t size) {
    struct timeval tv1, tv2;
    size_t sse_size = (size / 128);

    gettimeofday(&tv1, NULL);

/*
    memcpy(dst, src, sse_size*128);

    char *dst_end=dst+sse_size*128;
    while(dst!=dst_end){
        __m128i res = _mm_stream_load_si128((__m128i *)src);
        *((__m128i *)dst)=res;
        src+=16;
        dst+=16;
    }
*/

    __asm__ __volatile__ (
            "push 	%2			\n\t"
            "mov        $0, %%rax		\n\t"

            "1:					\n\t"
            "prefetchnta 128(%0,%%rax)		\n\t"
            "prefetchnta 160(%0,%%rax)		\n\t"
            "prefetchnta 192(%0,%%rax)		\n\t"
            "prefetchnta 224(%0,%%rax)		\n\t"

/*
            "movdqa 	(%0,%%rax), %%xmm0	\n\t"
            "movdqa 	16(%0,%%rax), %%xmm1	\n\t"
            "movdqa 	32(%0,%%rax), %%xmm2	\n\t"
            "movdqa 	48(%0,%%rax), %%xmm3	\n\t"
            "movdqa 	64(%0,%%rax), %%xmm4	\n\t"
            "movdqa 	80(%0,%%rax), %%xmm5	\n\t"
            "movdqa 	96(%0,%%rax), %%xmm6	\n\t"
            "movdqa 	112(%0,%%rax), %%xmm7	\n\t"
*/

            "movntdqa 	(%0,%%rax), %%xmm0	\n\t"
            "movntdqa 	16(%0,%%rax), %%xmm1	\n\t"
            "movntdqa 	32(%0,%%rax), %%xmm2	\n\t"
            "movntdqa 	48(%0,%%rax), %%xmm3	\n\t"
            "movntdqa 	64(%0,%%rax), %%xmm4	\n\t"
            "movntdqa 	80(%0,%%rax), %%xmm5	\n\t"
            "movntdqa 	96(%0,%%rax), %%xmm6	\n\t"
            "movntdqa 	112(%0,%%rax), %%xmm7	\n\t"


            "movntdq	%%xmm0, (%1,%%rax)	\n\t"
            "movntdq	%%xmm1, 16(%1,%%rax)	\n\t"
            "movntdq	%%xmm2, 32(%1,%%rax)	\n\t"
            "movntdq	%%xmm3, 48(%1,%%rax)	\n\t"
            "movntdq	%%xmm4, 64(%1,%%rax)	\n\t"
            "movntdq	%%xmm5, 80(%1,%%rax)	\n\t"
            "movntdq	%%xmm6, 96(%1,%%rax)	\n\t"
            "movntdq	%%xmm7, 112(%1,%%rax)	\n\t"

/*
            "movntps	%%xmm0, (%1,%%rax)	\n\t"
            "movntps	%%xmm1, 16(%1,%%rax)	\n\t"
            "movntps	%%xmm2, 32(%1,%%rax)	\n\t"
            "movntps	%%xmm3, 48(%1,%%rax)	\n\t"
            "movntps	%%xmm4, 64(%1,%%rax)	\n\t"
            "movntps	%%xmm5, 80(%1,%%rax)	\n\t"
            "movntps	%%xmm6, 96(%1,%%rax)	\n\t"
            "movntps	%%xmm7, 112(%1,%%rax)	\n\t"
*/

            "add	$128, %%rax		\n\t"
            "dec	%2			\n\t"
            "jnz 	1b			\n\t"
            "pop 	%2			\n\t"

            "sfence"
    :
    : "p" (src), "p" (dst), "r" (sse_size)
    : "%rax"
        );

    gettimeofday(&tv2, NULL);

    sse_size *= 128;
//    printf("Size: %i MB, Speed %.2lf GB/s\n", size/1024/1024, 1000000. * size / ((tv2.tv_sec - tv1.tv_sec) * 1000000 + tv2.tv_usec - tv1.tv_usec) / 1024 / 1024 / 1024);

    if (sse_size < size) 
        memcpy(dst + sse_size, src + sse_size, size - sse_size);
}
